// Read COPYING for licensing details.

#include <FL/ilu.h>
#include <stdio.h>
#include <stdlib.h>

int
main(int argc, char *argv[])
{
	ILuint x = 0, y = 0;
	ILboolean buttons[8] = { 0, 0, 0, 0, 0, 0, 0, 0 };
	ilOpen(IL_JOYSTICK_BIT | IL_KEYBOARD_BIT);
	ILboolean loop = IL_TRUE;
	while(loop)
	{
		ilRead(IL_JOYSTICK_BIT | IL_KEYBOARD_BIT);
		if(ilEvent(IL_JOYSTICK_BIT))
		{
			ILint params[3];
			iluGetEvent(IL_JOYSTICK_BIT, params);
			switch(params[0])
			{
				case IL_EVENT_TYPE_ABS:
					switch(params[1])
					{
						case IL_EVENT_CODE_ABS_X:
							if(params[2] < 100) x = -1;
							else if(params[2] > 500) x = 1;
							else x = 0;
							break;
						case IL_EVENT_CODE_ABS_Y:
							if(params[2] < 100) y = -1;
							else if(params[2] > 500) y = 1;
							else y = 0;
							break;
						case IL_EVENT_CODE_ABS_X2:
							if(params[2] < 100)
							{
								buttons[4] = 1; buttons[5] = 0;
							}
							else if(params[2] > 500)
							{
							       	buttons[4] = 0; buttons[5] = 1;
							}
							else buttons[4] = buttons[5] = 0;
							break;
						case IL_EVENT_CODE_ABS_Y2:
							if(params[2] < 100)
							{
								buttons[6] = 1; buttons[7] = 0;
							}
							else if(params[2] > 500)
							{
							       	buttons[6] = 0; buttons[7] = 1;
							}
							else buttons[6] = buttons[7] = 0;
							break;
						default: break;
					}
				break;
				case IL_EVENT_TYPE_KEY:
					switch(params[1])
					{
						case IL_EVENT_CODE_BTN_A: buttons[0] = params[2]; break;
						case IL_EVENT_CODE_BTN_B: buttons[1] = params[2]; break;
						case IL_EVENT_CODE_BTN_C: buttons[2] = params[2]; break;
						case IL_EVENT_CODE_BTN_D: buttons[3] = params[2]; break;
					}
				break;
			}
			
			printf("(%2i, %2i) [%1i][%1i][%1i][%1i][%1i][%1i][%1i][%1i]\r",
					x, y,
					buttons[0], buttons[1], buttons[2], buttons[3],
					buttons[4], buttons[5], buttons[6], buttons[7]);
			fflush(stdout);
		}
		if(ilEvent(IL_KEYBOARD_BIT))
		{
			ILint params[3];
			iluGetEvent(IL_KEYBOARD_BIT, params);
			if(iluIsEvent(params, IL_EVENT_TYPE_KEY, IL_EVENT_CODE_KEY_ESC, 1))
				loop = IL_FALSE;
		}
	}
	ilClose(IL_JOYSTICK_BIT | IL_KEYBOARD_BIT);
	return EXIT_SUCCESS;
}
