// Read COPYING for licensing details.

#include <FL/ilu.h>
#include <stdio.h>
#include <stdlib.h>

int
main(int argc, char *argv[])
{
	ILuint x = 0, y = 0, wheel = 0;
	ILboolean buttons[3] = {0, 0, 0};
	ilOpen(IL_MOUSE_BIT | IL_KEYBOARD_BIT);
	ILboolean loop = IL_TRUE;
	while(loop)
	{
		ilRead(IL_MOUSE_BIT | IL_KEYBOARD_BIT);
		if(ilEvent(IL_MOUSE_BIT))
		{
			ILint params[3];
			iluGetEvent(IL_MOUSE_BIT, params);
			switch(params[0])
			{
				case IL_EVENT_TYPE_REL:
					switch(params[1])
					{
						case IL_EVENT_CODE_REL_X: x += params[2]; break;
						case IL_EVENT_CODE_REL_Y: y += params[2]; break;
						case IL_EVENT_CODE_REL_WHEEL: wheel = params[2]; break;
						default: break;
					}
				break;
				case IL_EVENT_TYPE_KEY:
					switch(params[1])
					{
						case IL_EVENT_CODE_BTN_LEFT: buttons[0] = params[2]; break;
						case IL_EVENT_CODE_BTN_MIDDLE: buttons[1] = params[2]; break;
						case IL_EVENT_CODE_BTN_RIGHT: buttons[2] = params[2]; break;
					}
				break;
			}
			
			printf("(%6i, %6i) [%2i] [%1i][%1i][%1i]\r", x, y, wheel, buttons[0], buttons[1], buttons[2]);
			fflush(stdout);
		}
		if(ilEvent(IL_KEYBOARD_BIT))
		{
			ILint params[3];
			iluGetEvent(IL_KEYBOARD_BIT, params);
			if(iluIsEvent(params, IL_EVENT_TYPE_KEY, IL_EVENT_CODE_KEY_ESC, 1))
				loop = IL_FALSE;
		}
	}
	ilClose(IL_MOUSE_BIT | IL_KEYBOARD_BIT);
	return EXIT_SUCCESS;
}
