// Read COPYING for licensing details.

#ifndef _FIL_H_
#define _FIL_H_

#include <FL/il_defs.h>

typedef enum {
	IL_JOYSTICK_BIT = 1,
	IL_MOUSE_BIT = 2,
	IL_KEYBOARD_BIT = 4,
	IL_JOYSTICK_OPENED,
	IL_JOYSTICK_EVENT_TYPE,
	IL_JOYSTICK_EVENT_CODE,
	IL_JOYSTICK_EVENT_VALUE,
	IL_MOUSE_OPENED,
	IL_MOUSE_EVENT_TYPE,
	IL_MOUSE_EVENT_CODE,
	IL_MOUSE_EVENT_VALUE,
	IL_KEYBOARD_OPENED,
	IL_KEYBOARD_EVENT_TYPE,
	IL_KEYBOARD_EVENT_CODE,
	IL_KEYBOARD_EVENT_VALUE
} ILenum;

typedef enum { IL_TRUE = 1, IL_FALSE = !IL_TRUE } ILboolean;
typedef double ILdouble;
typedef float ILfloat;
typedef int ILint;
typedef unsigned int ILuint;
typedef int ILsizei;
typedef void ILvoid;

void
ilOpen(ILenum cap);

void
ilClose(ILenum cap);

ILboolean
ilIsOpened(ILenum cap);

void
ilRead(ILenum cap);

ILboolean
ilEvent(ILenum cap);

void
ilGetBooleanv(ILenum pname, ILboolean *params);

void
ilGetDoublev(ILenum pname, ILdouble *params);

void
ilGetFloatv(ILenum pname, ILfloat *params);

void
ilGetIntegerv(ILenum pname, ILint *params);

#endif
