// Read COPYING for licensing details.

#include <FL/il.h>
#include "joystick.h"
#include "mouse.h"
#include "keyboard.h"

void
ilOpen(ILenum cap)
{
	if((cap & IL_JOYSTICK_BIT) == IL_JOYSTICK_BIT) _ilJoystickOpen();
	if((cap & IL_MOUSE_BIT) == IL_MOUSE_BIT) _ilMouseOpen();
	if((cap & IL_KEYBOARD_BIT) == IL_KEYBOARD_BIT) _ilKeyboardOpen();
}

void
ilClose(ILenum cap)
{
	if((cap & IL_JOYSTICK_BIT) == IL_JOYSTICK_BIT) _ilJoystickClose();
	if((cap & IL_MOUSE_BIT) == IL_MOUSE_BIT) _ilMouseClose();
	if((cap & IL_KEYBOARD_BIT) == IL_KEYBOARD_BIT) _ilKeyboardClose();
}

ILboolean
ilIsOpened(ILenum cap)
{

	ILboolean ret;
	switch(cap)
	{
		case IL_JOYSTICK_OPENED: ret = _ilJoystickOpened(); break;
		case IL_MOUSE_OPENED: ret = _ilMouseOpened(); break;
		case IL_KEYBOARD_OPENED: ret = _ilKeyboardOpened(); break;
		default: break;
	}
	return ret;
}

void
ilRead(ILenum cap)
{
	if((cap & IL_JOYSTICK_BIT) == IL_JOYSTICK_BIT) _ilJoystickRead();
	if((cap & IL_MOUSE_BIT) == IL_MOUSE_BIT) _ilMouseRead();
	if((cap & IL_KEYBOARD_BIT) == IL_KEYBOARD_BIT) _ilKeyboardRead();
}

ILboolean
ilEvent(ILenum cap)
{
	ILboolean ret;
	switch(cap)
	{
		case IL_JOYSTICK_BIT: ret = _ilJoystickEvent(); break;
		case IL_MOUSE_BIT: ret = _ilMouseEvent(); break;
		case IL_KEYBOARD_BIT: ret = _ilKeyboardEvent(); break;
		default: break;
	}
	return ret;
}

void
ilGetBooleanv(ILenum pname, ILboolean *params)
{
}

void
ilGetDoublev(ILenum pname, ILdouble *params)
{
}

void
ilGetFloatv(ILenum pname, ILfloat *params)
{
}

void
ilGetIntegerv(ILenum pname, ILint *params)
{

	switch(pname)
	{
		case IL_JOYSTICK_EVENT_TYPE: params[0] = _ilJoystickGetEventType(); break;
		case IL_JOYSTICK_EVENT_CODE: params[0] = _ilJoystickGetEventCode(); break;
		case IL_JOYSTICK_EVENT_VALUE: params[0] = _ilJoystickGetEventValue(); break;
		case IL_MOUSE_EVENT_TYPE: params[0] = _ilMouseGetEventType(); break;
		case IL_MOUSE_EVENT_CODE: params[0] = _ilMouseGetEventCode(); break;
		case IL_MOUSE_EVENT_VALUE: params[0] = _ilMouseGetEventValue(); break;
		case IL_KEYBOARD_EVENT_TYPE: params[0] = _ilKeyboardGetEventType(); break;
		case IL_KEYBOARD_EVENT_CODE: params[0] = _ilKeyboardGetEventCode(); break;
		case IL_KEYBOARD_EVENT_VALUE: params[0] = _ilKeyboardGetEventValue(); break;
		default: break;
	}
}

