// Read COPYING for licensing details.

#include "config.h"
#include <FL/il.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void
_ilConfigGet(const char *device, char **file)
{
	FILE *config;
      	config = fopen("/etc/filrc", "r");
	if(!config)
	{
		char *pathname;
		asprintf(&pathname, "%s/.filrc", getenv("HOME"));
		config = fopen(pathname, "r");
		if(!config)
		{
			fprintf(stderr, "Configuration file %s not found\n", pathname);
			exit(EXIT_FAILURE);
		}
	}
	char *variable, *value;
	ILboolean found = IL_FALSE;
	while(!found && !feof(config))
	{
		fscanf(config, "%a[a-zA-Z0-9] = %a[^\n]\n", &variable, &value);
		if(strcmp(device, variable) == 0)
		{
			found = IL_TRUE;
			*file = strdup(value);
		}
	}
	if(!found)
	{
		fprintf(stderr, "Device not configured\n");
		exit(EXIT_FAILURE);
	}
}
