// Read COPYING for licensing details.

#include "../joystick.h"
#include "config.h"
#include <linux/input.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

static int _fd = -1;
static struct input_event _event;
static ssize_t _read;

void
_ilJoystickOpen()
{
	char *file;
	_ilConfigGet("joystick", &file);
	_fd = open(file, O_RDONLY | O_NONBLOCK);
	free(file);
}

void
_ilJoystickClose()
{
	close(_fd);
	_fd = -1;
}

ILboolean
_ilJoystickOpened()
{
	return (_fd != -1);
}

void
_ilJoystickRead()
{
	_read = read(_fd, &_event, sizeof(struct input_event));
}

ILboolean
_ilJoystickEvent()
{
	return ((_read > 0) && (_event.type != EV_SYN));
}

ILint
_ilJoystickGetEventType()
{
	return _event.type;
}

ILint
_ilJoystickGetEventCode()
{
	return _event.code;
}

ILint
_ilJoystickGetEventValue()
{
	return _event.value;
}
