// Read COPYING for licensing details.

#include "../keyboard.h"
#include "config.h"
#include <linux/input.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

static int _fd = -1;
static struct input_event _event;
static ssize_t _read = 0;

void
_ilKeyboardOpen()
{
	char *file;
	_ilConfigGet("keyboard", &file);
	_fd = open(file, O_RDONLY | O_NONBLOCK);
	free(file);
}

void
_ilKeyboardClose()
{
	close(_fd);
	_fd = -1;
}

ILboolean
_ilKeyboardOpened()
{
	return (_fd != -1);
}

void
_ilKeyboardRead()
{
	_read = read(_fd, &_event, sizeof(struct input_event));
}

ILboolean
_ilKeyboardEvent()
{
	return ((_read > 0) && (_event.type != EV_SYN));
}

ILint
_ilKeyboardGetEventType()
{
	return _event.type;
}

ILint
_ilKeyboardGetEventCode()
{
	return _event.code;
}

ILint
_ilKeyboardGetEventValue()
{
	return _event.value;
}
