// Read COPYING for licensing details.

#include "../mouse.h"
#include "config.h"
#include <linux/input.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

static int _fd = -1;
static struct input_event _event;
static ssize_t _read;

void
_ilMouseOpen()
{
	char *file;
	_ilConfigGet("mouse", &file);
	_fd = open(file, O_RDONLY | O_NONBLOCK);
	free(file);
}

void
_ilMouseClose()
{
	close(_fd);
	_fd = -1;
}

ILboolean
_ilMouseOpened()
{
	return (_fd != -1);
}

void
_ilMouseRead()
{
	_read = read(_fd, &_event, sizeof(struct input_event));
}

ILboolean
_ilMouseEvent()
{
	return ((_read > 0) && (_event.type != EV_SYN));
}

ILint
_ilMouseGetEventType()
{
	return _event.type;
}

ILint
_ilMouseGetEventCode()
{
	return _event.code;
}

ILint
_ilMouseGetEventValue()
{
	return _event.value;
}
